//
// Created by huli on 2020/10/20.
//

#include "carrier_task.h"

Carrier_task::Carrier_task()
{
	//构造函数锁定任务类型为 LOCATE_MANGER_TASK，后续不允许更改
	m_task_type = CARRIER_TASK;
	m_task_statu = TASK_CREATED;
	m_task_statu_information.clear();
	m_task_error_manager.error_manager_clear_all();

	m_parkspace_unit_id = 0;
	m_parkspace_floor_id = 0;
	m_parkspace_room_id = 0;
//	m_command_key = "";
	m_motion_direction = 0;
	m_car_center_x = 0;
	m_car_center_y = 0;
	m_car_angle = 0;



	unsigned short 						m_parkspace_floor_id;		//车位楼层号(楚天项目为1~14)
	unsigned short 						m_parkspace_room_id;		//车位同层的房间号	(楚天项目一楼为1~4, 楼上为1~6)
	std::string							m_command_key;				//任务唯一码
	unsigned char						m_motion_direction;			//调度方向, 根据停车取车选择出入口, 	1=入口，0=非入口
	float 								m_car_center_x;				//汽车的中心坐标x
	float 								m_car_center_y;				//汽车的中心坐标y
	float 								m_car_angle;				//汽车的旋转角(角度-90~90)

	//任务执行结果
	Respons_status						m_respons_status;			//指令完成状态, 搬运器答复指令, 返回任务完成的情况
}

Carrier_task::~Carrier_task()
{

}


//初始化任务单，必须初始化之后才可以使用，（可选参数）
//    input:tast_receiver 接受对象
//    input:task_over_time 超时时间
Error_manager Carrier_task::task_init(void* p_tast_receiver,
						std::chrono::milliseconds task_over_time,
						unsigned short parkspace_unit_id,
						unsigned shortparkspace_floor_id,
						unsigned shortparkspace_room_id,
						std::string command_key,
						unsigned char motion_direction,
						float car_center_x,
						float car_center_y,
						float car_angle
)
{
	m_task_statu = TASK_CREATED;
	m_task_statu_information.clear();
	m_task_error_manager.error_manager_clear_all();

	m_parkspace_unit_id = parkspace_unit_id;
	m_parkspace_floor_id = shortparkspace_floor_id;
	m_parkspace_room_id = shortparkspace_room_id;
	m_command_key = command_key;
	m_motion_direction = motion_direction;
	m_car_center_x = car_center_x;
	m_car_center_y = car_center_y;
	m_car_angle = car_angle;

	m_respons_status = RESPONS_NORMAL;
}









