//
// Created by huli on 2020/9/8.
//

#ifndef NNXX_TESTS_COMMON_DATA_H
#define NNXX_TESTS_COMMON_DATA_H


class Common_data
{
public:
	//万集雷达扫描周期66ms, (频率15hz), 一般设置大一些
#define WANJI_716_SCAN_CYCLE_MS 		70


	//整车的测量信息
	struct Car_measure_information
	{
		float center_x = 0;				//整车的中心点x值, 四轮的中心
		float center_y = 0;				//整车的中心点y值, 四轮的中心
		float car_angle = 0;			//整车的车身旋转角,
		float car_length = 0;			//整车的长度, 用于规避碰撞
		float car_width = 0;			//整车的宽度, 用于规避碰撞
		float car_height = 0;			//整车的高度, 用于规避碰撞
		float wheel_base = 0;			//整车的轮距, 前后轮的距离, 用于机器人或agv的抓车
		float wheel_width = 0;			//整车的轮距, 左右轮的距离, 用于机器人或agv的抓车
		float front_theta = 0;			//整车的前轮的旋转角

		bool correctness = false;			//整车的校准标记位

	};

	//四轮的测量信息
	struct Car_wheel_information
	{
		float center_x = 0;				//整车的中心点x值, 四轮的中心
		float center_y = 0;				//整车的中心点y值, 四轮的中心
		float car_angle = 0;			//整车的车身旋转角,

		float wheel_base = 0;			//整车的轮距, 前后轮的距离, 用于机器人或agv的抓车
		float wheel_width = 0;			//整车的轮距, 左右轮的距离, 用于机器人或agv的抓车
		float front_theta = 0;			//整车的前轮的旋转角

		bool correctness = false;			//整车的校准标记位

	};


	static void copy_data(Car_measure_information& car_measure_information_in, Car_wheel_information& car_wheel_information_out);
	static void copy_data(Car_wheel_information& car_wheel_information_in, Car_measure_information& car_measure_information_out);



};


#endif //NNXX_TESTS_COMMON_DATA_H
